<?php

/**
 * @file
 * Feeds integration for Number Double module.
 */

/**
 * Implements hook_feeds_processor_targets_alter().
 *
 * @see FeedsNodeProcessor::getMappingTargets()
 */
function number_double_feeds_processor_targets_alter(&$targets, $entity_type, $bundle_name) {
  foreach (field_info_instances($entity_type, $bundle_name) as $name => $instance) {
    $info = field_info_field($name);
    if ($info['type'] == 'number_double') {
      foreach ($info['columns'] as $subfield => $column) {
        $targets[$name] = array(
          'name' => check_plain($instance['label']),
          'callback' => 'number_double_feeds_set_target',
          'description' => t('The @label field of the entity.', array('@label' => $instance['label'])),
        );
      }
    }
  }
}

/**
 * Callback for mapping.
 */
function number_double_feeds_set_target(FeedsSource $source, $entity, $target, array $values, array $mapping) {
  $language = $mapping['language'];

  // Iterate over all values.
  $field = isset($entity->$target) ? $entity->$target : array($language => array());

  foreach ($values as $value) {

    if (is_object($value) && ($value instanceof FeedsElement)) {
      $value = $value->getValue();
    }

    if (is_numeric($value)) {
      $field[$language][] = array('value' => $value);
    }
  }

  $entity->$target = $field;
}
